function AaoTabletLink() {
	var AAO_URL_PART = "http://localhost:";
	var lastString = '';
	var dloop;

	function DataLoop () {
		let forceUpdate = SimVar.GetSimVarValue('L:AAO_FMC_HTML_INIT', 'Number');
		let apiport = SimVar.GetSimVarValue('L:AaoWebApiPort', 'Number');
		if (apiport != 0) {
			let bIdx = 1;
			let currStr = "";
			let requestObj = {};
			requestObj.setstringvars = [];
			requestObj.scripts = [];
			let btns = document.getElementsByTagName("button");
			if (btns){
				let currStr = "";
				for (let bi = 0; bi < btns.length; bi++){
					if (btns[bi] && btns[bi].id){
						let toset = { "var": "(L:PMDG_TABLET_BUTTON_" + (bIdx++).toString() + ", String)", "value": btns[bi].id };
						requestObj.setstringvars.push(toset);
						currStr += btns[bi].id;
					}
				}
			}
			btns = document.getElementsByClassName("icon");
			if (btns){
				for (let bi = 0; bi < btns.length; bi++){
					if (btns[bi] && btns[bi].id){
						let toset = { "var": "(L:PMDG_TABLET_BUTTON_" + (bIdx++).toString() + ", String)", "value": btns[bi].id };
						requestObj.setstringvars.push(toset);
						currStr += btns[bi].id;
					}
				}
			}
			btns = document.getElementsByClassName("custom-select");
			if (btns){
				for (let bi = 0; bi < btns.length; bi++){
					if (btns[bi] && btns[bi].id){
						let toset = { "var": "(L:PMDG_TABLET_SELECT_" + (bIdx++).toString() + ", String)", "value": btns[bi].id };
						requestObj.setstringvars.push(toset);
						currStr += btns[bi].id;
					}
				}
			}
			btns = document.getElementsByTagName("input");
			if (btns){
				for (let bi = 0; bi < btns.length; bi++){
					if (btns[bi] && btns[bi].id){
						if (btns[bi].type === 'checkbox' || btns[bi].type === 'radio' || btns[bi].type === 'range'){
							let toset = { "var": "(L:PMDG_TABLET_BUTTON_" + (bIdx++).toString() + ", String)", "value": btns[bi].id };
							requestObj.setstringvars.push(toset);
						} else{
							let toset = { "var": "(L:PMDG_TABLET_INPUT_" + (bIdx++).toString() + ", String)", "value": btns[bi].id };
							requestObj.setstringvars.push(toset);
						}
						currStr += btns[bi].id;
					}
				}
			}
			if (currStr !== lastString){
				lastString = currStr;
				let toset = { "code": "(EXPORTVARS:PMDG_TABLET,pmdgtabletitems)" };
				requestObj.scripts.push(toset);
				let relxhttp = new XMLHttpRequest();
				let relurl = encodeURI(AAO_URL_PART + apiport.toString() + "/webapi/");
				relxhttp.open("POST", relurl);
				relxhttp.send(JSON.stringify(requestObj));
			}
			var getrequestObj = {};
			getrequestObj.pullstringlvars = [];
			let tosend = { "var": "(L:PMDG_TABLET_BUTTON_PUSHED, String)", "value": ""};
			getrequestObj.pullstringlvars.push(tosend);
			tosend = { "var": "(L:PMDG_TABLET_KEY_PUSHED, String)", "value": ""};
			getrequestObj.pullstringlvars.push(tosend);
			tosend = { "var": "(L:PMDG_TABLET_SET_INPUT_FIELD, String)", "value": ""};
			getrequestObj.pullstringlvars.push(tosend);
			tosend = { "var": "(L:PMDG_TABLET_SET_SELECT_FIELD, String)", "value": ""};
			getrequestObj.pullstringlvars.push(tosend);
			var grelxhttp = new XMLHttpRequest();
			grelxhttp.addEventListener("load", aaoDataRequestListener);
			let relurl = encodeURI(AAO_URL_PART + apiport.toString() + "/webapi/");
			grelxhttp.open("POST", relurl);
			grelxhttp.send(JSON.stringify(getrequestObj));
		}
	};
	
	function aaoDataRequestListener (){
		let commObj = JSON.parse(this.responseText);
		let buttonArr = commObj.pullstringlvars[0].value;
		let btns = buttonArr.split(',');
		for (let bi = 0; bi < btns.length; bi++){
			let btn = document.getElementById(btns[bi]);
			if (btn)
				btn.click();
		}
		buttonArr = commObj.pullstringlvars[1].value;
		btns = buttonArr.split(',');
		for (let bi = 0; bi < btns.length; bi++){
			let btn = document.getElementById(btns[bi]);
			if (btn)
				btn.click();
		}
		let inpField = commObj.pullstringlvars[2].value;
		let prms = inpField.split(',');
		if (prms.length == 2){
			let ino = document.getElementById(prms[0]);
			ino.value = prms[1];
		}
		let selField = commObj.pullstringlvars[3].value;
		let selprms = selField.split(',');
		if (selprms.length == 2){
			let sel = document.getElementById(selprms[0]);
			if (sel){
				sel.click();
				let selopts = sel.getElementsByClassName("option");
				if (selopts){
					for (let si = 0; si < selopts.length; si++){
						if (selopts[si].innerText === selprms[1])
							selopts[si].click();
					}
					// sel.click();
					// sel.innerText = selprms[1];
				}
			}
		}
	};
	
	this.startup = function () {
		dloop = setInterval(DataLoop, 100);
	};
	
	this.shutdown = function () {
		clearInterval(dloop);
	};
};

var aaotabletmodule = new AaoTabletLink();
aaotabletmodule.startup();
